import java.util.*;
import java.io.*;

/* Challenge 2.
 *
 *
 * Have tried:
 *
 * k1+k2 +/- page msg
 *
 * k1+k2 +/- page msg run thru caesar cipher and vigenere cipher
 * 
 * (k1 + k2) + msg
 * (k1 + k2) - msg
 * msg - (k1 + k2)
 *
 */
public class Level2 {

	// Keys given in level 2
	static final String key1 = "BWMUVJAGUWEKGZFLWQVQBOECZIQUDGEPIIATMJYIF";
	static final String key2 = "WVGKJVUDVVMSTXFWPWPSSXGXHRNSDWRFSFQKGIUJM";

	static final String key = key1+key2;
	static final String bkey = key2+key1;
	static final String rkey = new StringBuilder(key).reverse().toString();

	// keys given in level 1
	static final String L1key = "VQZHPLNAXPPBEXANPNPUAZTJQAIGWHSRHDFLDIZNDMCOQKKTVEJRZDPAMKPBRCXPLBRCDAZJQGXVLOUVVXCYJHDGGHOUPJRVGDOFYEHZXFJZVBMNPFNWWFVS";

	// encrypted message contained in article
	static final String msg = "DVXVJLEEOTPEMKGGWVHSOTAJLEXGOZWUAKJQLZRGWQUHOYEKXSMVVRGDUCSJJELKPS";

	// From level 1
	static final String s1 = "IFYOUAREREADINGTHISYOUHAVEPASSEDTHEFIRSTTESTYOURCODEWORDISDISCOVER";

	// agreed-upon one time pad from example problem in article
	static final String pad = "HQWORJIHKSGSICOSFSSBPCWCHGXYOUMWEOYYWUKYLKVZVHSMRJPLGHXULJBT";

	public static void main(String[] args) { 
		method13();
	}





	public static void method13() {
		printStrings(addStrings(pad,key)); 
		printStrings(addStrings(pad,rkey)); 
		printStrings(addStrings(pad,bkey)); 
		printStrings(addStrings(pad,key1)); 
		printStrings(addStrings(pad,key2)); 
	}




	public static void method12() {
		// Failed results from last problem - key plus message, and key minus message
		String nope1 = "YLWCYWRELIEFQHGTLIWMOSTSBEFMKGOLHNOBOHQTZCWVEIODSWVMUUVDGMHKAGIZAT";
		String nope2 = "SVCMGAJWJWAXSNUHTSICMGTAFWLAIIWXHTWVSJIHHWIHCMGJYMXWEMJXSIXSIYMFWJ";

		printStrings(addStrings(nope1,key)); 
		printStrings(addStrings(nope2,key)); 

		printStrings(addStrings(nope1,rkey)); 
		printStrings(addStrings(nope2,rkey)); 

		printStrings(addStrings(nope1,bkey)); 
		printStrings(addStrings(nope2,bkey)); 

		printStrings(addStrings(nope1,key1)); 
		printStrings(addStrings(nope2,key1)); 

		printStrings(addStrings(nope1,key2)); 
		printStrings(addStrings(nope2,key2)); 



	}





	public static void methodOld(){

		// Tantalizingly close, but nothing.

		printStrings(addStrings(msg,key)); 
		printStrings(addStrings(msg,key1)); 
		printStrings(addStrings(msg,key2)); 

		printStrings(addStrings(s1,key)); 
		printStrings(addStrings(s1,key1)); 
		printStrings(addStrings(s1,key2)); 


		System.out.println("================");



		printStrings(addStrings(key1,key2)); 
		printStrings(addStrings(key,key)); 


		System.out.println("================");


		printStrings(addStrings(L1key,key)); 
		printStrings(addStrings(L1key,rkey)); 
		printStrings(addStrings(L1key,bkey)); 
		printStrings(addStrings(L1key,key1)); 
		printStrings(addStrings(L1key,key2)); 
		printStrings(addStrings(L1key,L1key)); 


		System.out.println("================");



		printStrings(addStrings(pad,key)); 
		printStrings(addStrings(pad,rkey)); 
		printStrings(addStrings(pad,bkey)); 
		printStrings(addStrings(pad,key1)); 
		printStrings(addStrings(pad,key2)); 
		printStrings(addStrings(pad,L1key)); 


		System.out.println("================");


		printStrings(addStrings(s1,key)); 
		printStrings(addStrings(s1,rkey)); 
		printStrings(addStrings(s1,bkey)); 
		printStrings(addStrings(s1,key1)); 
		printStrings(addStrings(s1,key2)); 
		printStrings(addStrings(s1,L1key)); 


		System.out.println("================");


		printStrings(addStrings(msg,key)); 
		printStrings(addStrings(msg,rkey)); 
		printStrings(addStrings(msg,bkey)); 
		printStrings(addStrings(msg,key1)); 
		printStrings(addStrings(msg,key2)); 
		printStrings(addStrings(msg,L1key)); 



		System.out.println("================");


	}





	// key 1 + key 2 +/- page message
	public static void method1() {

		StringBuffer msg_plus_key = new StringBuffer();
		StringBuffer msg_minus_key = new StringBuffer();
		StringBuffer key_minus_msg = new StringBuffer();

		for(int i=0; i<key1.length(); i++) { 

			char m = msg.charAt(i);
			int im = (int)(m - 'A');

			char k1 = key1.charAt(i);
			int ik1 = (int)(k1 - 'A');

			char k2 = key2.charAt(i);
			int ik2 = (int)(k2 - 'A');

			msg_plus_key.append( (char)( 'A' + (im+ik1+ik2+10*26)%26) );
			msg_minus_key.append( (char)('A' + (im-ik1-ik2+10*26)%26) );
			key_minus_msg.append( (char)('A' + (ik1+ik2-im+10*26)%26) );
		}

		System.out.println( msg_plus_key.toString() );
		System.out.println( msg_minus_key.toString() );
		System.out.println( key_minus_msg.toString() );
	}



	///////////////////////////////////////////////////////////////////




	public static void printStrings(String[] strings){  
		for(int i=0; i<strings.length; i++) { 
			System.out.println(strings[i]);
		}
	}



	public static String[] addStrings(String s1, String s2) { 
		String[] arr = new String[3];

		StringBuffer buff1 = new StringBuffer();
		StringBuffer buff2 = new StringBuffer();
		StringBuffer buff3 = new StringBuffer();

		int maxlen = Math.min(s1.length(), s2.length());

		for(int i=0; i<maxlen; i++){ 

			char c1 = s1.charAt(i);
			int ic1 = (int)(c1 - 'A');

			char c2 = s2.charAt(i);
			int ic2 = (int)(c2 - 'A');

			buff1.append( (char)( 'A' + ((ic1 + ic2 + 10*26)%26) ));
			buff2.append( (char)('A' + ((ic1 - ic2 + 10*26)%26)  )); 
			buff3.append( (char)('A' + ((ic2 - ic1 + 10*26)%26)  )); 
		}

		arr[0] = buff1.toString();
		arr[1] = buff2.toString();
		arr[2] = buff3.toString();

		return  arr;
	}

}

