"""
Attempt to crack the cipher 
by treating it as a vignere cipher.

This brute forces two- and three-character length vigenere keys

http://simonsingh.net/The_Black_Chamber/vigenere_cracking_tool.html
"""

from fractions import gcd
import numpy as np
from pprint import pprint 

p1 = "JK EJRNZU. IZT  GZ NRFJNUC QJ QTLU NUEJNC UVUNY QNTIZTDTIQGE QUDULSJIU EJIVUN ZTQGJI. FTYHU QSUY'C NUEJNCUC QSGZ ZUZZGJI"
p2 = "WO HJIBSJP HNIY MPO ZTOIUBOQ. WO GBQSOI NGWNYQ. UNHO N VJBUO, JTS JM SCO ENEOG JM SJIATOQ, QKONFBIA SJ TQ. BS KGNYOR TQ N HBACSY RTE."
p3 = "IUIMYFCI WTP PIEMIQP. DQ'P ASPQ T BTQQIM FR RDCGDCL FZQ VWTQ QWIY TMI."
p4 = "SHB ZGMKPSLJS SHZJO LIKUS QBTUPZSY. QYQSBGQ ZQJ's HKW SHBY WKPD, ZS'Q HKW SHBY RL ZF."
p5 = "MGV DGFN ZG XGS VCFQ QMTLT ETLLCNTL QG KTECIF LTYKTQ? ... I VCFQ QMTE QG KTECIF LTYKTQ OGK CL DGFN CL ETF CKT YCHCRDT GO TUID."
p6 = "OH XDQ VNCP PD RGGJ N ZGELGP, XDQ BQZP NAZD FOTG OP HLDB XDQLZGAH."


p1="JKEJRNZUIZTGZNRFJNUCQJQTLUNUEJNCUVUNYQNTIZTDTIQGEQUDULSJIUEJIVUNZTQGJIFTYHUQSUYCNUEJNCUCQSGZZUZZGJI"
p2="WOHJIBSJPHNIYMPOZTOIUBOQWOGBQSOINGWNYQUNHONVJBUOJTSJMSCOENEOGJMSJIATOQQKONFBIASJTQBSKGNYORTQNHBACSYRTE"
p3="IUIMYFCIWTPPIEMIQPDQPASPQTBTQQIMFRRDCGDCLFZQVWTQQWIYTMI"
p4="SHBZGMKPSLJSSHZJOLIKUSQBTUPZSYQYQSBGQZQJsHKWSHBYWKPDZSQHKWSHBYRLZF"
p5="MGVDGFNZGXGSVCFQQMTLTETLLCNTLQGKTECIFLTYKTQIVCFQQMTEQGKTECIFLTYKTQOGKCLDGFNCLETFCKTYCHCRDTGOTUID"
p6="OHXDQVNCPPDRGGJNZGELGPXDQBQZPNAZDFOTGOPHLDBXDQLZGAH"


'''
Repeated sequences and likely key lengths:

    problem 1: 2, 3, 6, 9, 18
    problem 2: 2, 3, 6, 9, 18
    problem 3: 19
    problem 4: EXACTLY 2, 7, 14
    problem 5: EXACTLY 2, 4, 8, 16
    problem 6: 2, 3, 4, 5, 7, 10 (?)

'''

problems = [p5]

for ip, problem in enumerate(problems):
    original = problem
    filename = "problem" + str(ip+1) + ".txt"

    with open(filename,'w') as f:

        for ii in range(26):
            for jj in range(26):
                key = ""
                key += chr(ord('a')+ii)
                key += chr(ord('a')+jj)
        
                ki = 0 # key index
                newstr = ""
                for c in original:
                    newchr = chr( ord('a') + (ord(c) + ord(key[ki]) )%26 )
                    ki = (ki + 1)%(len(key))
                    newstr += newchr
                
                f.write(newstr + "\n")

