from io import StringIO, BytesIO
from pprint import pprint

def hex_to_int(myHexString):
    """
    Convert hex value to int value.
    """
    return int(myHexString,16)

def convert_block_to_decimal(block):
    """
    Convert an entire block to decimal representation
    """
    #blockbuff = StringIO()  # <-- Screw StringIO. IT CANNOT EVEN TAKE A F***** STRING.
    # To the genius who named this class: if it is a unicode-only class that does not 
    # accept strings, maybe call it UnicdoeIO, and not StringIO. 

    blockbuff = ""

    for row in range(len(block)):
        for col in range(len(block[row])):
            # c is the character set,
            # n is the number converted from hex to decimal
            c = block[row][col]
            n = int(c,16)
            blockbuff += str(n)
            blockbuff += "\t"
        blockbuff += "\n"
    return blockbuff

def compute_frequencies(block):
    """
    Compute frequencies of symbols in blocks.
    """
    blockf = {}
    for row in range(len(block)):
        for col in range(len(block[row])):
            # c is the character set,
            # n is the number converted from hex to decimal
            c = block[row][col]
            n = int(c,16)

            if c in blockf.keys():
                blockf[c] += 1
            else:
                blockf[c] = 1

    return blockf

def compute_piano_location(block):
    """
    This computes the location of a given piano key.
    Assuming a key is given by F5,
    this computes the location of the 5th F from the left of the keyboard.

    So, F5 = (F) + (5*7)
    """
    blockf = {}
    for row in range(len(block)):
        for col in range(len(block[row])):
            # c is the character set,
            # n is the number converted from hex to decimal
            c = block[row][col]
            n = int(c,16)

            if c in blockf.keys():
                blockf[c] += 1
            else:
                blockf[c] = 1

    return blockf




if __name__=="__main__":

    # Load blocks
    
    block1 = []
    with open('block1.txt') as f:
        for line in f.readlines():
            block1.append(line.split())
    
    block2 = []
    with open('block2.txt') as f:
        for line in f.readlines():
            block2.append(line.split())


    # Add each symbol to the symbol table.
    # Increment frequency count for each symbol seen.
    
    for block in [block1]:#,block2]:
        print(convert_block_to_decimal(block))
        print(compute_frequencies(block))






    ### #blockbuff = StringIO()  # <-- Screw StringIO. IT CANNOT EVEN TAKE A F***** STRING.
    ### # To the genius who named this class: if it is a unicode-only class that does not 
    ### # accept strings, maybe call it UnicdoeIO, and not StringIO. 
    ###         ##### unicode can die
    ###         ####blockbuff.write(str(n))
    ###         ####blockbuff.write("\t")
    ###     ####blockbuff.write("\n")



